% *************************************************************************
% Date:    23.3.2015
% Source:  Gregor Cepon
% *************************************************************************

%--------------------------------------------------------------------------
% Numericno resevanje diferencialnih enacb II. reda
%--------------------------------------------------------------------------
% Oblika problema
% (m_P+m_V)*\ddot x1 + m_V(cos(alpha)+sin(alpha)*ni)*\ddot s = -ni*g*(m_P+m_V) (1)
%  m_V*cos(alpha)*\ddot x1+3/2*m_v*\ddot s = m_V*g*sin(alpha)           (2)
%-------------  -------------------------------------------------------------
% Primer reevanja diferencialne enabe drugega reda
%--------------------------------------------------------------------------
% Vhodni podatki
podatki.m_V = 1000;
podatki.m_P = 100;
podatki.g = 9.81;
podatki.ni = 0.1;  % Trenje naj ne bo veje of 0.1 (numerine teave)
podatki.alpha = deg2rad(25);
a = 4;
b = 1;
r = 0.2;

%  Zaetni pogoji 
x0p = [0;0];
x0v = [0;0];
%  Casovni interval
t_span = [0:0.02:8];

%  Resevanje problema 
options = odeset('RelTol',1e-6);
[T,X] = ode45(@enacbe_vaje,t_span,[x0p;x0v],options,podatki);

figure('Name','Pomik')
plot(T,X(:,1),'-r',T,X(:,2),'-b')
figure('Name','Hitrost')
plot(T,X(:,2))
%--------------------------------------------------------------------------
%  Izris simulacije
%--------------------------------------------------------------------------
figure
for i=1:size(T,1)
    x = [0 a 0]';
    x = x + X(i,1);
    y = [0.00 0.00 a*tan(podatki.alpha)]';
    fill(x,y,'r','EdgeColor','g','Linewidth',1.5);
    hold on
    circles(X(i,1)+X(i,2)*cos(podatki.alpha),1.1*r+y(end,1)-X(i,2)*sin(podatki.alpha),r,'rotation',rad2deg(-X(i,2)/r));
    text(3,1,['Cas=' num2str(T(i,1)) 's'],'EdgeColor','g');
    set(gcf,'Color','w')
    daspect([1 1 1])
    xlim([-4,4])
    ylim([0,3])
    alpha(0.5)
    pause(0.05);
    cla
end








